#include <stdlib.h>
#include <stdio.h>

#define OPERAND_BUFFER_SIZE 10

typedef struct {
    /* 
    Students: The Expression struct should hold the two operands and
    the operation (use a char for the operation)
    */
    int operator1;
    int operator2;
    char operation;
} Expression;

int bits_per_int() {
    return sizeof(unsigned int) * 8;
}

unsigned int parse_operand(char operand_str[]) {
    unsigned int operand;
    if (operand_str[0] == '0' && operand_str[1] == 'x') {
        sscanf(&operand_str[2], "%x", &operand);
    } else if (operand_str[0] == '0') {
        sscanf(&operand_str[1], "%o", &operand);
    } else {
        sscanf(operand_str, "%u", &operand);
    }
    return operand;
}

void print_binary(unsigned int value) {

    // Students: Print a single number as a binary string
    int chars[32];
    int counter;
    for(counter = 0; counter < 32; counter = counter + 1) {
        if((value % 2) == 0) {
            chars[counter] = 0;
        } else {
            chars[counter] = 1;
        }
        value = value / 2;
    }
    for(counter = 31; counter >= 0; counter--) {
        printf("%d", chars[counter]);
        if(counter == 24 || counter == 16 || counter == 8) {
            printf("'");
        }
    }
}

void print_bit_operation_bin(Expression expression, unsigned int result) {
    /* 
    Students: Print the entire operation in bin including the result

    Bin:
    00000000'00000000'00000000'00001100
    00000000'00000000'00000000'00001111 ^
    -----------------------------------
    00000000'00000000'00000000'00000011
    */

    printf("Bin:\n");
    print_binary(expression.operator1);
    printf("\n");
    print_binary(expression.operator2);
    printf(" %c\n", expression.operation);
    printf("-----------------------------------\n");
    print_binary(result);
    printf("\n");
}

void print_bit_operation_hex(Expression expression, unsigned int result) {
    /* 
    Students: Print the entire operation in hex including the result

    Hex:
    0x0c ^ 0x0f = 0x03
    */

    printf("\nHex:\n0x%x %c 0x%x\n0x%x\n", expression.operator1, expression.operation, expression.operator2, result);
}

void print_bit_operation_dec(Expression expression, unsigned int result) {
    /* 
    Students: Print the entire operation in hex including the result

    Dec:
    12 ^ 15 = 3
    */

	printf("\nDec:\n%d %c %d\n%d\n", expression.operator1, expression.operation, expression.operator2, result);
}

unsigned int bit_operation(Expression expression) {
    // Students: Do the actual bit operation and return the result
    switch(expression.operation) {
	case '&': return expression.operator1 & expression.operator2; break;
	case '|': return expression.operator1 | expression.operator2; break;
	case '^': return expression.operator1 ^ expression.operator2; break;
	case '<': return expression.operator1 < expression.operator2; break;
	case '>': return expression.operator1 > expression.operator2; break;
	default: printf("ubekannte Operation\n"); break;
    }
}

int main(){
    char operand1_str[10];
    char operand2_str[10];
    char operation;

    unsigned int operand1, operand2;

    do {
        printf("Geben sie die Bit-Operation ein:\n");

        scanf("%s %c %s", operand1_str, &operation, operand2_str);
        
        operand1 = parse_operand(operand1_str);
        operand2 = parse_operand(operand2_str);

        Expression expression;   // Students: Create an expression
        expression.operator1 = operand1;
        expression.operator2 = operand2;
	expression.operation = operation;

	

        unsigned int result = bit_operation(expression);
        print_bit_operation_bin(expression, result);
        print_bit_operation_hex(expression, result);
        print_bit_operation_dec(expression, result);

        while(getchar() != '\n');
        printf("\nMöchten sie weiter machen oder abbrechen? [(n)ext|(q)uit] ");

    } while(getchar() == 'n');

    printf("Byebye..\n");
    return EXIT_SUCCESS;
}

