/* ----------------------------------------------------------------------------
 * --  _____       ______  _____                                              -
 * -- |_   _|     |  ____|/ ____|                                             -
 * --   | |  _ __ | |__  | (___    Institute of Embedded Systems              -
 * --   | | | '_ \|  __|  \___ \   Zuercher Hochschule Winterthur             -
 * --  _| |_| | | | |____ ____) |  (University of Applied Sciences)           -
 * -- |_____|_| |_|______|_____/   8401 Winterthur, Switzerland               -
 * ----------------------------------------------------------------------------
 */
/**
 * @file
 * @brief Lab implementation
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "read.h"
#include "person.h"

int person_compare(const person_t *a, const person_t *b){
    //compaire name
    int result = strcmp(a->name, b->name);
    //if name is the same compare first_name
    if(result == 0){
        result = strcmp(a->first_name, b->first_name);
    }
    //if first_name is the same compare age
    if(result == 0){
        result = a->age - b->age;
    }
    return result;
}


int create_person(person_t *person){
    char input;
    int count;

    //read last name
    printf("Please enter Last Name:\n");
    count = 0;
    input = getchar();
    if((input == EOL) || (input == EOF)){
        return 0;
    }
    while((input != EOL) && (input != EOF)){
        if(count < NAME_LEN){
            person->name[count] = input;
        }
        count ++;
        input = getchar();
    }
    if(count > NAME_LEN){
        return 0;
    }
    person->name[count] = '\0';

    //read first name
    printf("Please enter First Name:\n");
    count = 0;
    input = getchar();
    if((input == EOL) || (input == EOF)){
        return 0;
    }
    while((input != EOL) && (input != EOF)){
        if(count < NAME_LEN){
            person->first_name[count] = input;
        }
        count ++;
        input = getchar();
    }
    if(count > NAME_LEN){
        return 0;
    }
    person->first_name[count] = '\0';

    //read age
    printf("Please enter age:\n");
    int age = getInt(100);
    if(age >= 0){
        person->age = age;
        return 1;
    }
    return 0;

}
